/*
*  source code metrics counter
*  Copyright (C) 2015-2016  NEC Corporation.
*  
*  This program is free software; you can redistribute it and/or
*  modify it under the terms of the GNU General Public License
*  as published by the Free Software Foundation; either version 2
*  of the License, or (at your option) any later version.
*  
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <tchar.h>
#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibDateW.h"
#include "CDMtrLibSigW.h"
#include "CDMtrLibOptW.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntFunc.h"
#include "CDMtrCntFirstLine.h"
#include "CDMtrCntLineCount.h"
#include "CDMtrCntOptions.h"
#include "CDMtrCntProperties.h"
#include "CDMtrCntLog.h"
#include "CDMtrCntCK.h"
#include "CDMtrCntOutputCSV.h"
#include "CDMtrCntOutputXML.h"
#include "CDMtrCntExtTool.h"
#include "CDMtrCntCompileEnv.h"
#include "CDMtrCntStructure.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrCntXrefDataUtil.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* structure definition                                                       */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* global variable declaration                                                */
/*----------------------------------------------------------------------------*/
_OPTINFO gtOptInfo_lc;
_TCHAR *pcNkfDllPath = NULL;
static HINSTANCE ghNkfDLL = NULL;
_TCHAR *pcCharSet = NULL;
_TCHAR *pcStartDate = NULL;
_TCHAR *pcEndDate = NULL;
_TCHAR *pcCommandOptions = NULL;
_TCHAR *pcCommandOptions_MODE = NULL;
_TCHAR *pcCommandOptions_OTHER = NULL;
_TCHAR *pcKnownOptsCmdBuf = NULL;
size_t szKnownOptsCmdBufSize = 0;
int iExecuteMode = ROW_MODE;
int iStructMode = 0;
int iDiffMode = 0;
int giRestyleMode = RESTYLE_STD;
int giRestyleBothFlg = CDMTR_FALSE;
int giBothHeadFlg = CDMTR_FALSE;
int iSkipChangeFlg = CDMTR_TRUE;
int iOutFileFormat = CSV_FORMAT;
int giDiffBlankFlg = CDMTR_FALSE;
int giDiffCountMode = DIFF_COUNT_STD;
int giExceptBinaryMode = CDMTR_FALSE;
int giStmtMode = CDMTR_TRUE;
int giFANIOMode = CDMTR_TRUE;
_TCHAR *pcObjectName = NULL;
_TCHAR *pcObjectPath = NULL;    //!< sĂncmeter̃pX(exe͊܂܂Ȃ)
_TCHAR *pcOutFileName = NULL;   //!< sĂncmeter̃pX(exe܂)
const _TCHAR *pcOutFileNameLogOut = NULL;
_TCHAR *pcProfFileName = NULL;
const _TCHAR *pcProfFileNameLogOut = NULL;
int iProfileFlag = CDMTR_TRUE;
int giProfileNKFEXESetting = CDMTR_FALSE;
int giDocFlag = CDMTR_TRUE;
int giCmntCaseFlag = CDMTR_TRUE;
FILE *spcOutFile = NULL;
FILE *fp_diff_ret_file = NULL;
_TCHAR *pcKnownOpts = NULL;
int iShowDetails = DETAILS_HIDE;
int iShowHelp = HELP_HIDE;
int iDebug = DEBUG_OFF ;
long giPerformance = PERFORMANCE_OFF ;
int iSpsDebug = DEBUG_OFF ;
int giMoreDebug = DEBUG_OFF;
_TCHAR *pcResultCodeOpts = NULL;
_TCHAR *pcLogCodeOpts = NULL;
_TCHAR *pcDoc = NULL;
_TCHAR *pcDef = NULL;
_TCHAR *pcParse = NULL;
_TCHAR *pcSkip = NULL;
_TCHAR *pcNkf = NULL;
_TCHAR *pcNkfExe = NULL;
_TCHAR *pcNkfExeDefault = NULL;
_TCHAR *pcBeautifier = NULL;
_TCHAR *pcBeautifierExe = NULL;
_TCHAR *pcBeautifierExeDefault = NULL;
_TCHAR *pcBeautifierCfgDefault = NULL;
_TCHAR *pcDiffParse = NULL;
_TCHAR *pcDiffOpMode = NULL;
_TCHAR *pcDiffBlank = NULL;
_TCHAR *pcDiffCountMode = NULL;
_TCHAR *pcExceptBinary = NULL;
_TCHAR *pcFuncOpt = NULL;
_TCHAR *pcJAVAExe = NULL;
_TCHAR *pcJAVAVmOptionXmx = NULL;
_TCHAR *pcCmntCase = NULL;
_TCHAR *pcStmtMode = NULL;
_TCHAR *pcFanIOMode = NULL;
_TCHAR *pcTempFio = NULL;
_TCHAR *pcTempXref = NULL;
_TCHAR *pcCharsetOutCsv_prop = NULL;
_TCHAR *pcQrc_option = NULL;
_TCHAR *pcCharsetOutLog_prop = NULL;
_TCHAR *pcQlg_option = NULL;
_TCHAR *pcNcmDebugProp = NULL;
int iNestsCount = NUM_NESTS_COUNT_NONE;
int iDiffModeDetailOut = DIFF_MODE_DETAIL_OUT_NONE;
int iNumOfFiles = 0;
int iNumOfSuccess = 0;
int iNumOfSuccessJava = 0;
int iNumOfUnrecognized = 0 ;
_TCHAR *pcTempFolderName = NULL;
_TCHAR *pcMacroAnalizerPath = NULL;
_TCHAR *pcSedToolPath = NULL;
_TCHAR *pcDiffPath = NULL;
_TCHAR *pcStructPath = NULL;
_TCHAR *pcStructSmpPath = NULL;
_TCHAR *pcStructJAVAPath = NULL;
_TCHAR *pcStructCSPath = NULL;
_TCHAR *pcStructVBPath = NULL;
_TCHAR *pcStructJSPath = NULL;
_TCHAR *pcCkJAVAPath = NULL;
_TCHAR *pcHelpPath = NULL;
int iSourceID = 0;
#if NEED_SOURCE_ID
_TCHAR chSourceID[SOURCEID_LEN + 1];
#else
_TCHAR *chSourceID = _T("0");
#endif
_TCHAR *pcJAVAExeVersion = NULL;
_TCHAR *pcProcessID = NULL;
_TCHAR *gpcCompType = NULL;
_TCHAR *gpcCompOpt = NULL;
_TCHAR *gpcSysInc = NULL;
int giPlType = 0;
_TCHAR *gpcCompTypeForC = NULL;
_TCHAR *gpcCompTypeForJava = NULL;
_TCHAR *gpcQrtLiteral = NULL;
int giQrtOutFlg = CDMTR_FALSE;
_TCHAR *gpcOutputFormat = NULL;
int   globaliLangType = LANG_TYPE_UNKNOW;
int giOutFileAdd = CDMTR_FALSE;
int giOutHeaderFlg = CDMTR_TRUE;
int giOutFooterFlg = CDMTR_TRUE;



/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/
static _SysLocale stSysLocale;

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static void cdmtrCntMainReleaseVariable(void);
static int cdmtrCntMainCheckOutFileName(void);
static void cdmtrCntMainShowHelpFile(const _TCHAR *pcBasePath, _SysLocale *ptSysLocale);
static int cdmtrCntMainDeleteTempFile(void);
static BOOL cdmtrCntMainSigHandle(DWORD iSigNum);
static void cdmtrCntMainTerm(void);
static int cdmtrCntMainRegisterHandler(void);
static int cdmtrCntMainGetPLType(void);
static int cdmtrCntMainInitialize(void);
static int cdmtrCntMainCreateTempFolder(void);
static int cdmtrCntMainCreateToolPath(void);
static int cdmtrCntMainOutputHelpLog(int argc);
static int cdmtrCntMainSetCompilerOption(void);
static int cdmtrCntMainCalculate(void);

/*----------------------------------------------------------------------------*/
/* global function declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
@brief                  C֐
*/
int _tmain(int argc, _TCHAR *argv[])
{
    DWORD clockStart = 0 ;
    DWORD clockEnd = 0 ;
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
#ifdef CDMTR_DEBUG
    _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
#endif
    /* \p̊JnԂ擾 */
    clockStart = timeGetTime();

    /**  */
    /** 'cdmtrCntMainInitialize' functionalities
    *  - Signal handling
    *	- Windows platform confirmation
    *	- Allocate memory for and sets value of various variables 
    *    related to the path of 'ncmeter.exe'	
    */
    iFuncRet = cdmtrCntMainInitialize();
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    /** Oc[pX쐬 */
    /** 'cdmtrCntMainCreateToolPath' functionalities
    *   - Sets up variables that point to various exe's and other 
    *     important files
    *   - e.g.:- maext.exe, sedext.exe, diff.exe, saext.exe, ncmsmpparser.exe,
    *     ncmjparser.exe, ncmvbparser.exe, ncmjsparser.exe, uncrustify.exe etc	
    */
    iFuncRet = cdmtrCntMainCreateToolPath();
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    /** IvV͂ */
    /** Find out what option (command) has been given 
    *  e.g. - row, diff, struct etc.
    */

    iFuncRet = CDMtrCntOptionsAnalyzeOption(argc, argv, &stSysLocale);
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    if (argc > 1 && iShowHelp != HELP_SHOW) {
        /** R}hɎw肳ꂽt@C(tH_)mF */
        /* wv\sꍇ͑sȂ߁Ȁ͎sȂ */
        /**Find out what file name/path has been given. */
        iFuncRet = CDMtrCntOptionsAnalyzeInputFiles(argc, argv);
        if (iFuncRet != RET_OK) {
            goto FUNC_EXIT;
        }
    }

    /** vpeB͂ */
    iFuncRet = CDMtrCntPropertiesAnalyzeProperty();
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    /** Oo͂̕Zbgݒ肷 */
    CDMtrLibCmnSetLogCharsetW(pcLogCodeOpts);

    /** wv̕\𔻒f */
    /** Check for various situations under which the help file 
    *  needs to be shown.
    *  e.g. - only ncmeter has been entered or ncmeter --help 
    *  has been entered.
    */
    iFuncRet = cdmtrCntMainOutputHelpLog(argc);
    if (iFuncRet == RET_SHOW_HELP) {
        /* wv\߁AncmeterI */
        iRet = RET_OK;
        goto FUNC_EXIT;
    }

    /** R}hɎw肳ꂽ͑Ώۃt@C(tH_)mF */
    /** Check whether 'sptInFileNames' has been defined or not. 
    *  Also if iExecuteMode is diff, then whether two files have been 
    *  specified or not.
    */
    iFuncRet = CDMtrCntOptionsCheckFile();
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    /** e|tH_쐬 */
    /** Create a folder with the name ncmeter + processId.
    *  The location of this folder is stored in 'pcTempFolderName' variable.
    */
    iFuncRet = cdmtrCntMainCreateTempFolder();
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    /** RpCIvVݒ肷 */
    /** Sets up variable that points to the compiler version to be used.
    *  eg - JDK_1_5
    */
    iFuncRet = cdmtrCntMainSetCompilerOption();
    if (iFuncRet != RET_OK) {
        goto FUNC_EXIT;
    }

    /** Check if debug option is on and print debug information if it is. */
    if (iDebug == DEBUG_ON) {
        /* IvV/vpeB̎wlOɏo͂ */
        CDMtrCntLogPrintDebugInfos(DEBUG_PRINT_LOG, &stSysLocale);
        if (iOutFileFormat == CSV_FORMAT) {
            /* 茋ʂCSV`̏ꍇ̂݁A茋ʃt@C̕ZbgOɏo͂ */
            CDMtrCntLogPrintCsvOutCharset(&stSysLocale);
        }
    }



    /** NKF DLL[h */
    /** Load the path of nkf32.dll into a handle. Also load the addresses 
    *  of various functions in nkf i.e 'funcSetNkfOption' and 'funcNkfConvert2SafeW'.
    */
    if (giProfileNKFEXESetting != CDMTR_TRUE) {                           
        iFuncRet = CDMtrCntExtToolLoadNKFDLL(&ghNkfDLL);
        if (iFuncRet != RET_OK)   
            goto FUNC_EXIT;
    }


    /** 茋ʃt@CI[v */
    /** Create variable for ncmeter.csv absolute filepath and open the file.
    *  The pointer to the file is stored in spcOutFileName.	
    */
    iFuncRet = cdmtrCntMainCheckOutFileName();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /* \pOo (Jn) */
    if ((giPerformance & PERFORMANCE_LVL2) > 0) {
        CDMtrLibCmnLogOut(_T("[PERF],%#x,%.3f,<<StartTime>>,21,1\n"), PERFORMANCE_LVL2, (float)clockStart / 1000); //* MSG_LOG_ID_C_00000204
    }

    /** gNX̑s */
    /** Calculate structure metrics */
    iFuncRet = cdmtrCntMainCalculate();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;



FUNC_END:
    /* \pOo */
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("Measured,21,3")); //* MSG_LOG_ID_C_00000396

    /** st@CꍇAt@COɏo͂ */
    if (iNumOfUnrecognized > 0) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000205, iNumOfUnrecognized); //* MSG_LOG_ID_C_00000205
    }

    /** t@CƑ茋ʂOɏo͂ (-v/-debugw莞) */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000209); //* MSG_LOG_ID_C_00000209
    }
    if (iShowDetails == DETAILS_SHOW || iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000206, iNumOfSuccess); //* MSG_LOG_ID_C_00000206
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000207, (iNumOfFiles - iNumOfSuccess)); //* MSG_LOG_ID_C_00000207
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000208, iNumOfFiles); //* MSG_LOG_ID_C_00000208
    }

    /** I擾 */
    if (pcEndDate == NULL) {
        pcEndDate = CDMtrLibDateGetTime();
    }

    /* 茋ʃt@CɋNƏIo͂ */
    /** This section prints all the information about the current execution
    *  session i.e all the data that comes after the input file data.
    */
    if (giOutFooterFlg) {
        if (iOutFileFormat == CSV_FORMAT) {                        //!<if output file is in csv format
            CDMtrCntOutputCSVWriteInfomation(&stSysLocale);
        } else {
            CDMtrCntOutputXMLWriteXMLInfomation(&stSysLocale);     //!<if output file is in xml format
        }
    }

    /** 茋ʃt@CN[Y */
    if (spcOutFile != NULL) {
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("CloseFile : [output] <S>")); //* MSG_LOG_ID_C_00000397
        fclose(spcOutFile);
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("CloseFile : [output] <E>")); //* MSG_LOG_ID_C_00000398
        spcOutFile = NULL;
    }

FUNC_EXIT:
    /** e|tH_ƃe|t@C폜 */

    /** If 'debug2' option is not on, then delete all the files in the 
    *  temp folder and delete the folder. 
    */
    if (iSpsDebug != DEBUG_ON) {
        /* -debug2IvVw肳Ăꍇ폜Ȃ */
        cdmtrCntMainDeleteTempFile();
        if (pcTempFolderName) {
            _trmdir(pcTempFolderName);
        }
    }


    /** NKF DLL */
    /** Free the handle pointing to the nkf file. */
    CDMtrCntExtToolFreeNKFDLL(ghNkfDLL);

    /** ncmeteȑIXe[^XOo͂ (-debugw莞) */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000213, iRet); //* MSG_LOG_ID_C_00000213
    }

    /* \pOo */
    MACRO_MEMORY_PUTLOG(MEMORY_LVL1, DEFINE_MEMORY_NCMETER_NAME, pcCommandOptions_MODE, NULL, GetCurrentProcessId());
    MACRO_MEMORY_TITLE_PUTLOG(MEMORY_LVL1);
    if ((giPerformance & PERFORMANCE_LVLMAX) > 0) {
        clockEnd = timeGetTime();
        CDMtrLibCmnLogOut(_T("[PERF],%#x,%.3f,[[StartTime]]\n"), PERFORMANCE_LVL1, (float)clockStart / 1000); //* MSG_LOG_ID_C_00000214
        CDMtrLibCmnLogOut(_T("[PERF],%#x,%.3f,[[EndTime]]\n"), PERFORMANCE_LVL1, (float)clockEnd / 1000); //* MSG_LOG_ID_C_00000215
        CDMtrLibCmnLogOut(_T("[PERF],%#x,%.3f,[[ExecTime]]\n"), PERFORMANCE_LVL1, (float)(clockEnd - clockStart) / 1000); //* MSG_LOG_ID_C_00000216
    }
    /** Iϐ̃s */
    cdmtrCntMainReleaseVariable();

    return iRet;
}

/*!
@brief  Iϐ̉
*/
static void cdmtrCntMainReleaseVariable(void)
{
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000217); //* MSG_LOG_ID_C_00000217
    }
    /* ͑Ώۃt@C(tH_)Xg̉s */
    CDMtrCntOptionsFreeFileList();
    CDMtrCntXrefDataUtilFreeAllXrefTables();
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcUserLang));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcUserCountry));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcUserOEMCodePage));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcUserANSICodePage));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcUserDispLang));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcSysLang));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcSysCountry));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcSysOEMCodePage));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcSysANSICodePage));
    CDMtrLibUtilFreeW((void **) & (stSysLocale.pcSysDispLang));
    CDMtrLibUtilFreeW((void **)&pcDoc);
    CDMtrLibUtilFreeW((void **)&pcDef);
    CDMtrLibUtilFreeW((void **)&pcParse);
    CDMtrLibUtilFreeW((void **)&pcSkip);
    CDMtrLibUtilFreeW((void **)&pcNkf);
    CDMtrLibUtilFreeW((void **)&pcNkfExe);
    CDMtrLibUtilFreeW((void **)&pcNkfExeDefault);
    CDMtrLibUtilFreeW((void **)&pcBeautifier);
    CDMtrLibUtilFreeW((void **)&pcBeautifierExe);
    CDMtrLibUtilFreeW((void **)&pcBeautifierExeDefault);
    CDMtrLibUtilFreeW((void **)&pcBeautifierCfgDefault);
    CDMtrLibUtilFreeW((void **)&pcDiffParse);
    CDMtrLibUtilFreeW((void **)&pcDiffOpMode);
    CDMtrLibUtilFreeW((void **)&pcDiffBlank);
    CDMtrLibUtilFreeW((void **)&pcDiffCountMode);
    CDMtrLibUtilFreeW((void **)&pcExceptBinary);
    CDMtrLibUtilFreeW((void **)&pcJAVAExe);
    CDMtrLibUtilFreeW((void **)&pcJAVAExeVersion);
    CDMtrLibUtilFreeW((void **)&pcJAVAVmOptionXmx);
    CDMtrLibUtilFreeW((void **)&pcCmntCase);
    CDMtrLibUtilFreeW((void **)&pcStmtMode);
    CDMtrLibUtilFreeW((void **)&pcFuncOpt);
    CDMtrLibUtilFreeW((void **)&pcCharsetOutCsv_prop);
    CDMtrLibUtilFreeW((void **)&pcQrc_option);
    CDMtrLibUtilFreeW((void **)&pcCharsetOutLog_prop);
    CDMtrLibUtilFreeW((void **)&pcQlg_option);
    CDMtrLibUtilFreeW((void **)&pcNcmDebugProp);
    CDMtrLibUtilFreeW((void **)&pcStartDate);
    CDMtrLibUtilFreeW((void **)&pcEndDate);
    CDMtrLibUtilFreeW((void **)&pcCommandOptions);
    CDMtrLibUtilFreeW((void **)&pcCommandOptions_MODE);
    CDMtrLibUtilFreeW((void **)&pcCommandOptions_OTHER);
    CDMtrLibUtilFreeW((void **)&pcKnownOptsCmdBuf);
    CDMtrLibUtilFreeW((void **)&pcObjectName);
    CDMtrLibUtilFreeW((void **)&pcObjectPath);
    CDMtrLibUtilFreeW((void **)&pcOutFileName);
    CDMtrLibUtilFreeW((void **)&pcProfFileName);
    CDMtrLibUtilFreeW((void **)&pcKnownOpts);
    CDMtrLibUtilFreeW((void **)&pcTempFolderName);
    CDMtrLibUtilFreeW((void **)&pcMacroAnalizerPath);
    CDMtrLibUtilFreeW((void **)&pcSedToolPath);
    CDMtrLibUtilFreeW((void **)&pcDiffPath);
    CDMtrLibUtilFreeW((void **)&pcStructPath);
    CDMtrLibUtilFreeW((void **)&pcStructSmpPath);
    CDMtrLibUtilFreeW((void **)&pcStructJAVAPath);
    CDMtrLibUtilFreeW((void **)&pcStructCSPath);
    CDMtrLibUtilFreeW((void **)&pcStructVBPath);
    CDMtrLibUtilFreeW((void **)&pcStructJSPath);
    CDMtrLibUtilFreeW((void **)&pcCkJAVAPath);
    CDMtrLibUtilFreeW((void **)&pcHelpPath);
    CDMtrLibUtilFreeW((void **)&pcProcessID);
    CDMtrLibUtilFreeW((void **)&gpcCompType);
    CDMtrLibUtilFreeW((void **)&gpcCompTypeForC);
    CDMtrLibUtilFreeW((void **)&gpcCompTypeForJava);
    CDMtrLibUtilFreeW((void **)&gpcQrtLiteral);
    CDMtrLibUtilFreeW((void **)&gpcOutputFormat);
    CDMtrLibUtilFreeW((void **)&gpcCompOpt);
    CDMtrLibUtilFreeW((void **)&gpcSysInc);
    CDMtrLibUtilFreeW((void **)&pcCharSet);
    CDMtrLibUtilFreeW((void **)&pcFanIOMode);
    CDMtrLibUtilFreeW((void **)&pcResultCodeOpts);
    CDMtrLibUtilFreeW((void **)&pcLogCodeOpts);
    CDMtrCntLangFreeInfo();
    CDMtrCntFirstLineFreeInfo();
    CDMtrLibUtilFreeW((void **)&pcNkfDllPath);
    return;
}

/*!
@brief      茋ʃt@CI[v
*/
static int cdmtrCntMainCheckOutFileName(void)
{
    int iRet = RET_NG;
    int iFuncRet;
    unsigned char BOM_UTF8[3] = {0xEF, 0xBB, 0xBF};
    if (pcOutFileName == NULL) {
        CDMtrLibUtilFreeW((void **)&pcOutFileName);
        if (iOutFileFormat == XML_FORMAT) {
            iFuncRet = CDMtrLibFileGetAbsolutePath(OUT_XML_FILE_NAME, &pcOutFileName);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        } else {
            /** Create path for ncmeter.csv file. */
            iFuncRet = CDMtrLibFileGetAbsolutePath(OUT_FILE_NAME, &pcOutFileName);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }
    pcOutFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcOutFileName);
    if (spcOutFile != NULL) {
        iRet = RET_OK;
        goto FUNC_END;
    }
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000218, pcOutFileNameLogOut); //* MSG_LOG_ID_C_00000218
    }
    if (giOutFileAdd) {
        if ((spcOutFile = _tfopen(pcOutFileName, _T("a"))) == NULL) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000113, pcOutFileNameLogOut); //* MSG_LOG_ID_C_00000113
            goto FUNC_END;
        }
    } else {
        if ((spcOutFile = _tfopen(pcOutFileName, _T("w"))) == NULL) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000114, pcOutFileNameLogOut); //* MSG_LOG_ID_C_00000114
            goto FUNC_END;
        }
        if (iOutFileFormat == CSV_FORMAT &&
            CDMtrLibUtilCompStringW(pcResultCodeOpts, ENCODING_UTF_8) == RET_TRUE) {
                if (fwrite(BOM_UTF8, sizeof(BOM_UTF8), 1, spcOutFile) < 1) {
                    if (spcOutFile != NULL) {
                        fclose(spcOutFile);
                        spcOutFile = NULL;
                    }
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000115, pcOutFileNameLogOut); //* MSG_LOG_ID_C_00000115
                    goto FUNC_END;
                }
        } else {
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
@brief          wv\
*/
static void cdmtrCntMainShowHelpFile(const _TCHAR *pcBasePath, _SysLocale *ptSysLocale)
{
    int iFuncRet;
    _TCHAR *pcFileFullPath = NULL;
    if (pcBasePath == NULL) {
        goto FUNC_END;
    }
    if (ptSysLocale->pcUserDispLang != NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcFileFullPath, pcBasePath, FOLDER_SEPALATE, ptSysLocale->pcUserDispLang, FOLDER_SEPALATE, HELP, NULL);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000122, pcBasePath, FOLDER_SEPALATE, ptSysLocale->pcUserDispLang, FOLDER_SEPALATE, HELP); //* MSG_LOG_ID_C_00000122
            goto FUNC_END;
        }
    } else {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcFileFullPath, pcBasePath, FOLDER_SEPALATE, LOCALE_LANGUAGE_CULTURE_ENGLISH, FOLDER_SEPALATE, HELP, NULL);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000123, pcBasePath, FOLDER_SEPALATE, LOCALE_LANGUAGE_CULTURE_ENGLISH, FOLDER_SEPALATE, HELP); //* MSG_LOG_ID_C_00000123
            goto FUNC_END;
        }
    }
    iFuncRet = CDMtrCntMainShowFile(pcFileFullPath);
    if (iFuncRet != RET_OK) {
        if (ptSysLocale->pcUserDispLang != NULL) {
            if (pcFileFullPath != NULL) {
                CDMtrLibUtilFreeW((void **)&pcFileFullPath);
            }
            iFuncRet = CDMtrLibUtilCreateStringW(&pcFileFullPath, pcBasePath, FOLDER_SEPALATE, LOCALE_LANGUAGE_CULTURE_ENGLISH, FOLDER_SEPALATE, HELP, NULL);
            if (iFuncRet != RET_OK) {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000124, pcBasePath, FOLDER_SEPALATE, LOCALE_LANGUAGE_CULTURE_ENGLISH, FOLDER_SEPALATE, HELP); //* MSG_LOG_ID_C_00000124
                goto FUNC_END;
            }
            iFuncRet = CDMtrCntMainShowFile(pcFileFullPath);
            if (iFuncRet != RET_OK) {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000125, pcFileFullPath); //* MSG_LOG_ID_C_00000125
                goto FUNC_END;
            }
        }
    }
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcFileFullPath);
    return;
}

/*!
@brief          w肳ꂽt@C̓eOɏo͂
*/
int CDMtrCntMainShowFile(const _TCHAR *pcFileName)
{
    int iFuncRet = RET_NG;
    FILE *fp = NULL;
    _TCHAR *cBuffer = NULL;
    _TCHAR *pcRet = NULL;
    if (pcFileName == NULL) {
        goto FUNC_END;
    }
    if ((fp = _tfopen(pcFileName, _T("r, ccs=UTF-8"))) == NULL) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000126, pcFileName); //* MSG_LOG_ID_C_00000126
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&cBuffer, BUFF_LINE_SIZE);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    while (1) {
        pcRet = _fgetts(cBuffer, BUFF_LINE_LENGTH, fp);
        if (pcRet == NULL) {
            break;
        }
        CDMtrLibCmnLogOut(_T("%s"), cBuffer); //* MSG_LOG_ID_C_00000219
    }
    CDMtrLibCmnLogOut(_T("\n")); //* MSG_LOG_ID_C_00000220
FUNC_END:
    if (fp) {
        fclose(fp);
        fp = NULL;
    }
    CDMtrLibUtilFreeW((void **)&cBuffer);
    return iFuncRet;
}

/*!
@brief      e|tH_z̃t@Cׂč폜
*/
static int cdmtrCntMainDeleteTempFile(void)
{
    int iRet = RET_NG;
    int iFuncRet;
    if (pcTempFolderName) {
        iFuncRet = CDMtrLibFileDeleteDirAll(pcTempFolderName, CDMTR_FALSE);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
@brief      VOȉIs
*/
static BOOL cdmtrCntMainSigHandle(DWORD iSigNum)
{
    BOOL bRet;
    bRet = TRUE;
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000283); //* MSG_LOG_ID_C_00000283
    }
    switch (iSigNum) {
    case CTRL_C_EVENT:
    case CTRL_BREAK_EVENT:
    case CTRL_CLOSE_EVENT:
    case CTRL_LOGOFF_EVENT:
    case CTRL_SHUTDOWN_EVENT:
        /** qvZXI */
        CDMtrCntCallProcessKill();
        /** ncmeter̋Is */
        cdmtrCntMainTerm();
        bRet = FALSE;
        break;
    default:
        break;
    }
    return bRet;
}

/*!
@brief  I
*/
static void cdmtrCntMainTerm(void)
{
    int iRetry = DELETE_RETRY_MAX;
    if (spcOutFile != NULL) {
        fclose(spcOutFile);
        spcOutFile = NULL;
    }
    CDMtrCntExtToolFreeNKFDLL(ghNkfDLL);
    while (iRetry > 0) {
        if (pcTempFolderName) {
            if (CDMtrLibFileDeleteDirAll(pcTempFolderName, CDMTR_TRUE) != RET_OK) {
                iRetry--;
                if (iDebug == DEBUG_ON) {
                    CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000285, DELETE_RETRY_MAX - iRetry, pcTempFolderName); //* MSG_LOG_ID_C_00000285
                }
                if (iRetry == 0) {
                    CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000286, pcTempFolderName); //* MSG_LOG_ID_C_00000286
                    break;
                }
                continue;
            } else {
                if (iDebug == DEBUG_ON) {
                    CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000287, pcTempFolderName); //* MSG_LOG_ID_C_00000287
                }
                break;
            }
        }
    }
    cdmtrCntMainReleaseVariable();
    return;
}

/*!
@brief      VOinh̓o^s
*/
static int cdmtrCntMainRegisterHandler()
{
    int iRet = RET_NG;
    int iFuncRet;
    iFuncRet = CDMtrLibSigRegHandler(cdmtrCntMainSigHandle, NULL);
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000177); //* MSG_LOG_ID_C_00000177
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
@brief      vbgtH[ʂ擾
*/
static int cdmtrCntMainGetPLType(void)
{
    int iType;
    iType = PLATFORM_TYPE_WIN;
    return iType;
}



/*!
@brief      hCȍs
*/
static int cdmtrCntMainInitialize(void)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int iProcessID = 0;
    int iBufLength = 0;
    _TCHAR *pcFileName = NULL;

    /** P[i[̈ */
    memset(&stSysLocale, 0x00, sizeof(_SysLocale));

    /** VOinho^ */
    /** Signal handling processing */
    iFuncRet = cdmtrCntMainRegisterHandler();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** s̃vbgtH[ʂ擾*/
    giPlType = cdmtrCntMainGetPLType();

    /** sĂncmeter̃tpX擾 */
    /** Allocate a memory location for pcObjectName and apply memset on 
    *  (*pcObjectName) with value 0. 
    */
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcObjectName, (FILE_PATH_SIZE + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /** Function "GetModuleFileName" sets the path of ncmeter.exe to 
    *  pcObjectName 
    */
    if (GetModuleFileName(NULL, pcObjectName, FILE_PATH_SIZE) == 0) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000073); //* MSG_LOG_ID_C_00000073
        goto FUNC_END;
    }
    /** pcFilename points to '/ncmeter.exe'. */
    pcFileName = _tcsrchr(pcObjectName, FOLDER_SEPALATE_CHAR);
    if (pcFileName == NULL) {
        goto FUNC_END;
    }
    *pcFileName = 0x00;

    /** Set pcObjectPath to the path of the 'Debug' folder. */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcObjectPath, pcObjectName, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (GetModuleFileName(NULL, pcObjectName, FILE_PATH_SIZE) == 0) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000074); //* MSG_LOG_ID_C_00000074
        goto FUNC_END;
    }

    /** sĂncmeter̃vZXID擾 */
    /** Get process id. */
    iProcessID = _getpid();


    iBufLength = (CDMtrLibUtilGetNumSizeW(iProcessID) + 1);
    /** Allocate memory for pcProcessID of size iBufLength and apply 
    *  memset for value 0x00. 
    */
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcProcessID, iBufLength * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    swprintf_s(pcProcessID, iBufLength, _T("%d"), iProcessID);

    /** Jn擾 */
    pcStartDate = CDMtrLibDateGetTime();

    /** P[擾 */
    CDMtrLibSystemSetLocaleAttrW(&stSysLocale);

    iRet = RET_OK;

FUNC_END:
    return iRet;
}


/*!
@brief      e|tH_쐬
*/
static int cdmtrCntMainCreateTempFolder(void)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcEnv = NULL;
    int iTmpAlias = 0;
    int iWindowsDirectory = 0;
    _TCHAR strTmpAlias[3];
    _TCHAR *pcTmpAlias = NULL;	

    /** e|tH_pX̐ */
    pcEnv = _tgetenv(TMPDIR_NAME_TMP);
    if (pcEnv == NULL) {
        pcEnv = _tgetenv(TMPDIR_NAME_TEMP);
        if (pcEnv == NULL) {
            pcEnv = _tgetenv(TMPDIR_NAME_USERPROFILE);
            if (pcEnv == NULL) {
                pcEnv = _tgetenv(TMPDIR_NAME_WINDIR);
            }
        }
    }
    if (pcEnv) {
        CDMtrLibUtilFreeW((void **)&pcTempFolderName);
        iFuncRet = CDMtrLibUtilCreateStringW(&pcTempFolderName, pcEnv, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        iWindowsDirectory = GetWindowsDirectory(NULL, 0);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcTempFolderName, (iWindowsDirectory + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = GetWindowsDirectory(pcTempFolderName, iWindowsDirectory);
        if (iFuncRet == 0) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000080); //* MSG_LOG_ID_C_00000080
            goto FUNC_END;
        }
    }
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTempFolderName, FOLDER_SEPALATE, TMP_FOLDER_NAME, pcProcessID, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /** e|tH_쐬 */
    iFuncRet = _tmkdir(pcTempFolderName);
    if (iFuncRet == RET_OK) {
        /* e|tH_̍쐬ɐ */
        iRet = RET_OK;
        goto FUNC_END;
    }

    /* e|tH_̍쐬Ɏsꍇ */
    /* łɓtH_݂\邽߁Ae|tH_폜čēx쐬s */
    iFuncRet = CDMtrLibFileDeleteDirAll(pcTempFolderName, CDMTR_TRUE);
    if (iFuncRet == RET_OK) {
        iFuncRet = _tmkdir(pcTempFolderName);
        if (iFuncRet != RET_OK) {
            /* e|tH_̍č쐬Ɏs */
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000110, pcTempFolderName); //* MSG_LOG_ID_C_00000110
            goto FUNC_END;
        } else {
            /* e|tH_̍쐬ɐ */
            iRet = RET_OK;
            goto FUNC_END;
        }
    }

    /* e|tH_̍폜Ɏsꍇ */
    /* ʖŃe|tH_̍쐬s */
    for (iTmpAlias = 0; iTmpAlias < CREATE_TMPFOLDER_RETRY_MAX; iTmpAlias++) {
        iFuncRet = _itot_s(iTmpAlias, strTmpAlias, sizeof(strTmpAlias) / sizeof(_TCHAR), 10);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        CDMtrLibUtilFreeW((void **)&pcTmpAlias);
        iFuncRet = CDMtrLibUtilCreateStringW(&pcTmpAlias, pcTempFolderName, STR_UNDERBAR, strTmpAlias, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibFileIsDir(pcTmpAlias);
        if (iFuncRet == RET_TRUE) {
            iFuncRet = CDMtrLibFileDeleteDirAll(pcTmpAlias, CDMTR_TRUE);
            if (iFuncRet == RET_NG) {
                continue;
            }
        }
        iFuncRet = _tmkdir(pcTmpAlias);
        if (iFuncRet == RET_OK) {
            break;
        }
    }

    if (iFuncRet == RET_OK) {
        /* ʖł̃e|tH_̍쐬ɐ */
        /* e|tH_tH_쐬ʖe|tH_ɒu */
        CDMtrLibUtilFreeW((void **)&pcTempFolderName);
        pcTempFolderName = pcTmpAlias;
        pcTmpAlias = NULL;  // h~
    } else {
        /* e|tH_̍쐬Ɏs */
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000111); //* MSG_LOG_ID_C_00000111
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcTmpAlias);
    return iRet;
}

/*!
@brief      Oc[pX쐬
*/
static int cdmtrCntMainCreateToolPath(void)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcWorkPath = NULL;

    /** maext.exẽpX쐬 */
    /** Set pcMacroAnalizerPath to NULL. */
    CDMtrLibUtilFreeW((void **)&pcMacroAnalizerPath);

    /** Set pcMacroAnalizerPath to the path of maext.exe ( maext.exe should be in the bin folder). */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcMacroAnalizerPath, DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, MACROANALIZER, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** sedext.exẽpX쐬 */
    /** Set pcSedToolPath to NULL. */
    CDMtrLibUtilFreeW((void **)&pcSedToolPath);

    /** Set pcSedToolPath to the path of sedext.exe (sedext.exe should be in the bin folder). */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcSedToolPath, DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, SEDTOOL, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** diff.exẽpX쐬 */
    /** Set pcDiffPath to NULL. */
    CDMtrLibUtilFreeW((void **)&pcDiffPath);

    /** Set pcDiffPath to the path of diff.exe (diff.exe should be in the bin folder). */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcDiffPath, DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, DIFF, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** saext.exẽpX쐬 */
    /** Set pcStructPath to NULL. */
    CDMtrLibUtilFreeW((void **)&pcStructPath);

    /** Set pcStructPath to the path of saext.exe ( bin folder). */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcStructPath, DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ncmsmpparser.exẽpX쐬 */
    CDMtrLibUtilFreeW((void **)&pcStructSmpPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcStructSmpPath, DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_SMP, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ncmjparser.jarsR}h쐬 */
    CDMtrLibUtilFreeW((void **)&pcStructJAVAPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcStructJAVAPath, DEFAULT_EXEC_JAVA_APP,
        DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_JAVA, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ncmckjparser.jarsR}h쐬 */
    CDMtrLibUtilFreeW((void **)&pcCkJAVAPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCkJAVAPath, EXEC_CK_JAVA_APP, EXEC_CK_JAVA_APP_OPTION_XSS,
        EXEC_CK_JAVA_APP_OPTION_XMX, JAVA_APP_OPTION_XMX_DEFAULT, EXEC_CK_JAVA_APP_OPTION_JAR,
        DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, CK_JAVA, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** Javao[W\ssR}h쐬 */
    CDMtrLibUtilFreeW((void **)&pcJAVAExeVersion);

    /** Set pcJAVAExeVersion to "java -version". */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcJAVAExeVersion, EXEC_JAVA_VERSION_CMD, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ncmcsparser.exẽpX쐬 */
    CDMtrLibUtilFreeW((void **)&pcStructCSPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcStructCSPath,
        DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_CS, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ncmvbparser.exẽpX쐬 */
    CDMtrLibUtilFreeW((void **)&pcStructVBPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcStructVBPath,
        DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_VB, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ncmjsparser.jarsR}h쐬 */
    CDMtrLibUtilFreeW((void **)&pcStructJSPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcStructJSPath, DEFAULT_EXEC_JAVA_APP,
        DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_JS, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /** uncrustify.exẽpX쐬 */
    CDMtrLibUtilFreeW((void **)&pcBeautifierExeDefault);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcBeautifierExeDefault, DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, BEAUTIFIER, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /* uncrustify.exẽIvVɎw肷uncrustify.cfg̃pX́ApXɂȂ\邽ShortPathϊsB */
    /* A uncrustify.exe̓OpXLƂłȂ߁Auncrustify.cfg̃pX̐K͍sȂB*/
    CDMtrLibUtilFreeW((void **)&pcWorkPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcWorkPath, pcObjectPath, ENVIRONMENT_PATH, BEAUTIFIER_CFG, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetShortPathWithinMaxpathW(pcWorkPath, &pcBeautifierCfgDefault);
    if (iFuncRet != RET_OK) {
        pcBeautifierCfgDefault = CDMtrLibUtilCopyString(pcWorkPath);
    }
    CDMtrLibUtilFreeW((void **)&pcWorkPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcBeautifierExeDefault, BEAUTIFIER_CFG_OPTION, DOUBLEQUOTATION, pcBeautifierCfgDefault, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** nkf32.dll̃pX쐬 */
    CDMtrLibUtilFreeW((void **)&pcNkfDllPath);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcNkfDllPath, pcObjectPath, NKF_DLL_PATH, NKFDLL, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;

FUNC_END:
    return iRet;
}


/*!
@brief      wv̕\𔻒f
*/
static int cdmtrCntMainOutputHelpLog(int argc)
{
    int iRet = RET_CONTINUE;

    /** ncmeter̃IvVɉw肳ĂȂꍇAwv\s */
    if (argc == 1) {
        cdmtrCntMainShowHelpFile(pcObjectPath, &stSysLocale);
        CDMtrCntLogPrintLogCharset(&stSysLocale);
        iRet = RET_SHOW_HELP;
        goto FUNC_END;
    }

    /** -debugIvVw肳ĂꍇAncmeterJnOo͂ */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000195); //* MSG_LOG_ID_C_00000195
    }

    /** -v܂-debugIvVw肳ĂꍇAncmeter̃o[WOo͂ */
    if (iShowDetails == DETAILS_SHOW || iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000197, TOOL_VER); //* MSG_LOG_ID_C_00000197
    }

    /** --helpIvVw肳ĂꍇAwv\s */
    if (iShowHelp == HELP_SHOW) {
        cdmtrCntMainShowHelpFile(pcObjectPath, &stSysLocale);
        CDMtrCntLogPrintLogCharset(&stSysLocale);
        iRet = RET_SHOW_HELP;
        goto FUNC_END;
    }

    /** -v܂-debugIvVw肳ĂꍇAOo͎̕ZbgOo͂ */
    if (iShowDetails == DETAILS_SHOW || iDebug == DEBUG_ON) {
        CDMtrCntLogPrintLogCharset(&stSysLocale);
    }

FUNC_END:
    return iRet;
}


/*!
@brief      RpCEIvVݒ肷
*/
static int cdmtrCntMainSetCompilerOption(void)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    /** C/C++͗pRpCŗLIvV擾 */
    iFuncRet = CDMtrCntCompileEnvGetEDGOption(gpcCompTypeForC);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** Java͗pRpCŗLIvV擾 */
    iFuncRet = CDMtrCntCompileEnvGetJavaOption(&gpcCompTypeForJava);
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000112, gpcCompTypeForJava); //* MSG_LOG_ID_C_00000112
        goto FUNC_END;
    }

    /** 茋ʂ[Command Parameter]ɏo͂镶̐(IvV) */
    if (pcKnownOpts == NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_SEPARATE_SPACE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize , OPTION_SEPARATE_SPACE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    /** C/C++͗pRpCŗLIvV̊mF */
    if (gpcCompOpt == NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&gpcCompOpt, OPTION_SEPARATE_SPACE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    /** VXeCN[hpX̊mF */
    if (gpcSysInc == NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&gpcSysInc, OPTION_SEPARATE_SPACE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;

FUNC_END:
    return iRet;
}

/*!
@brief      gNX̑s
*/
static int cdmtrCntMainCalculate(void)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    /** Structure containing array of all directories given to ncmeter.exe */
    _FileList *pInFileNames = NULL;                        
    _FileList *pInOptFileNames = NULL;

    while (1) {

        /** wb_[𑪒茋ʃt@Cɏo͂ */
        /** Write the header data in the output file */

        if (iOutFileFormat == CSV_FORMAT) {                     
            if (giOutHeaderFlg) {
                /** If the output file is in csv format */
                iFuncRet = CDMtrCntOutputCSVWriteHeader();            
            } else {
                iFuncRet = RET_OK;
            }
        } else {
            /** If the output file is in xml format */
            iFuncRet = CDMtrCntOutputXMLWriteXMLHeader();             
        }
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        if ((giOutHeaderFlg && !giOutFooterFlg) ||
            (!giOutHeaderFlg && giOutFooterFlg)
            ) {
                iRet = RET_OK;
                goto FUNC_END;
        }

        /* \pOo */
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("Initialized,21,2")); //* MSG_LOG_ID_C_00000395

        /** ͑Ώۃt@C(tH_)Xg擾 */
        /** Get the name of directories/files entered on the command 
        *  line while entering ncmeter.exe command 
        */
        pInFileNames = CDMtrCntOptionsGetInputFiles();
        /** ⏕NXt@CXg擾 */
        /** Get the name of options entered on the command line while 
        *  entering ncmeter.exe command 
        */
        pInOptFileNames = CDMtrCntOptionsGetOptFiles();

        switch (iExecuteMode) {
            /** If '-row' option is entered */
        case ROW_MODE:                                                   
            /** {ss */
            iFuncRet = CDMtrCntLineCountDoCountProcess(pInFileNames);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;
            /** If '-diff' option is entered */
        case DIFF_MODE:                                                 
            /** ss */
            iFuncRet = CDMtrCntLineCountDoDiffProcess(pInFileNames);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;
            /** If '-struct' option is entered */
        case STRUCT_MODE:                    
            /** Close the final output file. */
            if( !(iStructMode == OPTION_STRUCT_STD && giFANIOMode == CDMTR_TRUE) ){
                if(spcOutFile != NULL){
                    fclose(spcOutFile);
                    spcOutFile = NULL;
                }
            }
            /** \gNXs */
            iFuncRet = CDMtrCntStructureDoStructProcess(pInFileNames);			
            iNumOfSuccess=iNumOfSuccess+iNumOfSuccessJava;
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;
#ifndef OSS
        case CK_MODE:
            /** CKgNXs */
            iFuncRet = CDMtrCntCKDoCkProcess(pInFileNames, pInOptFileNames);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;
#endif //OSS
        default:
            break;
        }
        if (giRestyleBothFlg) {
            /** \[XR[h`̎w肪uv̏ꍇ(-RESTYLE BOTHA\[XR[h`Ȃōđs */
            iNumOfFiles = 0;
            iNumOfSuccess = 0;
            giRestyleBothFlg = CDMTR_FALSE;

            /* e|tH_ɂFANIN/FANOUT茋ʈꎞt@C폜Ă */
            if (iStructMode == OPTION_STRUCT_STD && giFANIOMode == CDMTR_TRUE) {
                iFuncRet = CDMtrLibUtilCreateStringW(&pcTempXref, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE_XREF, NULL);
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                CDMtrLibFileDelete(pcTempXref);
                CDMtrLibUtilFreeW((void **)&pcTempXref);
                iFuncRet = CDMtrLibUtilCreateStringW(&pcTempFio, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE_FIO, NULL);
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                CDMtrLibFileDelete(pcTempFio);
                CDMtrLibUtilFreeW((void **)&pcTempFio);
            }

            /* \[XR[h`̎wuȂvɕύX */
            CDMtrLibUtilFreeW((void **)&pcBeautifier);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcBeautifier, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcBeautifier, CNT_STR_FALSE);


            if (iOutFileFormat == XML_FORMAT) {
                /* 茋ʃt@CXML`̏ꍇAwb_do͂Ȃ悤ɖh~ */
                giBothHeadFlg = CDMTR_TRUE;
            } else {
                /* 茋ʃt@CCSV`̏ꍇA`/Ȃ̑茋ʂ̊Ԃɋs} */
                CDMtrCntOutputCSVWriteBlank();
            }
            continue;
        } else {
            break;
        }
    }

    iRet = RET_OK;
FUNC_END:
    return iRet;
}
