package com.nec.jp.ncmeter.struct.js;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import com.nec.jp.ncmeter.cmn.log.NCMCmnLog;

/**
 * JSparserpԗxNX
 */
public class CoverageTest {

	/* TODO basedir ɂẮAObVeXgp̃fBNgɕύX邱ƁB */
	private static final String basedir = "D:\\Program Files\\work\\ncmeter\\svn_swf\\test\\RegressionTest\\Function\\04_ncmeter_struct\\JS\\src\\TP\\";
	private static final String target = basedir + "CoverageTest.txt";
	private static final String optMVal = basedir;
	private static final String optTVal = "test.js";

	private static final String fileSJIS = basedir
			+ "\\01.ncmeter\\S7.6_A4.2_T1_sjis.js";
	private static final String fileEUC = basedir
			+ "\\01.ncmeter\\S7.6_A4.2_T1_euc.js";
	private static final String fileUNI = basedir
			+ "\\01.ncmeter\\S7.6_A4.2_T1_unicode.js";

	private String[] defaultArgs = { "--m", optMVal, "--t", optTVal, "--n",
			"0", "-version", "170", "--charset", "UTF-8" };

	String file = basedir + "\\01.ncmeter\\t.01.001.js";

	/**
	 * C֐
	 * 
	 * @param args
	 */
	public static void main(String args[]) {
		CoverageTest main = new CoverageTest();
		/* Ώۃt@CXg擾@ */
		String[] files = main.getTargetFiles(target);
		/* s@ */
		if (files != null) {
			main.run(files);
			main.run_options(files);
		}
	}

	private void run(String[] files) {
		int jsargLen = defaultArgs.length + 1;
		String[] jsargs = new String[jsargLen];
		/* IvVݒ */
		int i = 0;
		for (; i < defaultArgs.length; i++) {
			jsargs[i] = defaultArgs[i];
		}

		for (String file : files) {
			/* vt@Cݒ */
			jsargs[i] = file;
			/* s */
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
	}

	private void run_options(String[] files) {
		{
			/* optionȂ */
			String[] jsargs = {};
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* -m Ȃ */
			String[] jsargs = {
					// "--m", optMVal,
					"--t", optTVal, "--n", "0", file };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* -t Ȃ */
			String[] jsargs = { "--m", optMVal,
					// "--t", optTVal,
					"--n", "0", file };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* -n Ȃ */
			String[] jsargs = { "--m", optMVal, "--t", optTVal,
					// "--n", "0",
					file };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* --charset w */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					"--charset", "UTF-8", fileUNI };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + fileUNI);
		}
		{
			/* --charset w */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					"--charset", "Shift-JIS", fileSJIS };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + fileSJIS);
		}
		{
			/* --charset w */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					"--charset", "EUC-JP", fileEUC };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + fileEUC);
		}
		{
			/* --charset wȂ */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					fileUNI };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + fileUNI);
		}
		{
			/* --charset wȂ */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					fileSJIS };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + fileSJIS);
		}
		{
			/* --charset wȂ */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					fileEUC };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + fileEUC);
		}
		{
			/* -version w */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					"-version", "170", file };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* file Ȃ +wv\ */
			String[] jsargs = { "-help"
			// file
			};
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* file w肳ĂȂ */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
			// file
			};
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* file ݂Ȃ */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
			"file not found...."
			};
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* file  */
			String[] jsargs = { file, file, };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
		{
			/* fobOIvV */
			String[] jsargs = { "--m", optMVal, "--t", optTVal, "--n", "0",
					"--debug", "--debug2", file };
			NCMJSMain main = new NCMJSMain();
			int exitCode = main.run(jsargs);
			NCMCmnLog.outputLogDebug("exit code = " + exitCode);
			System.out.println("run[" + exitCode + "]" + " : " + file);
		}
	}

	private String[] getTargetFiles(String target) {
		File f = new File(target);
		/* t@CXgS擾 */
		String data = readSource(f);
		if (data == null)
			return null;
		/* s擾 */
		String br = System.getProperty("line.separator");
		/* sŕ */
		String[] files = data.split(br);
		return files;
	}

	private String readSource(File f) {
		String data = null;
		String absPath = f.getAbsolutePath();
		if (!f.isFile()) {
			System.out.println("Not file :" + absPath);
			return null;
		}
		try {
			InputStream is = null;
			File file = new File(absPath);
			int capacityHint = (int) file.length();
			try {
				is = new FileInputStream(file);
				byte[] bytedata = readStream(is, capacityHint);
				data = new String(bytedata);
			} catch (IOException ioe) {
				System.out.println(ioe.getMessage());
			} finally {
				if (is != null) {
					is.close();
				}
			}
		} catch (FileNotFoundException ex) {
			System.out.println(ex.getMessage());
		} catch (IOException ioe) {
			System.out.println(ioe.getMessage());
		}
		return data;
	}

	private byte[] readStream(InputStream is, int initialBufferCapacity)
			throws IOException {
		if (initialBufferCapacity <= 0) {
			throw new IllegalArgumentException("Bad initialBufferCapacity: "
					+ initialBufferCapacity);
		}
		byte[] buffer = new byte[initialBufferCapacity];
		int cursor = 0;
		for (;;) {
			int n = is.read(buffer, cursor, buffer.length - cursor);
			if (n < 0) {
				break;
			}
			cursor += n;
			if (cursor == buffer.length) {
				byte[] tmp = new byte[buffer.length * 2];
				System.arraycopy(buffer, 0, tmp, 0, cursor);
				buffer = tmp;
			}
		}
		if (cursor != buffer.length) {
			byte[] tmp = new byte[cursor];
			System.arraycopy(buffer, 0, tmp, 0, cursor);
			buffer = tmp;
		}
		return buffer;
	}
}
